=== debian/changelog ===
sonivox (3.6.11-2) unstable; urgency=medium

  * Honor the nocheck profile while building
    Thanks to Nilesh Patra (Closes: #1022186)
  * Fix d/watch regex for github

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 22 Oct 2022 14:03:11 +0200

sonivox (3.6.11-1) unstable; urgency=medium

  * Initial release (Closes: #1018164)

 -- Dennis Braun <d_braun@kabelmail.de>  Fri, 26 Aug 2022 13:30:23 +0200
