=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/sonivox-$1\.tar\.gz/ \
 https://github.com/pedrolcl/sonivox/tags .*/releases/tag/v?@ANY_VERSION@
