=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #[=========================================================================[
-  Copyright (c) 2022 Pedro López-Cabanillas
+  Copyright (c) 2022-2023 Pedro López-Cabanillas
 
   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
