=== debian/changelog ===
sonivox (3.6.12-1) unstable; urgency=medium

  * New upstream version 3.6.12
  * Change my email address
  * Bump Standards-Version to 4.6.2
  * Bump d/copyright years
  * Refresh d/watch

 -- Dennis Braun <snd@debian.org>  Mon, 12 Jun 2023 20:13:52 +0200
