=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: sound
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders: Dennis Braun <d_braun@kabelmail.de>
+Uploaders: Dennis Braun <snd@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -10,7 +10,7 @@
 Homepage: https://github.com/pedrolcl/sonivox
 Vcs-Browser: https://salsa.debian.org/multimedia-team/sonivox
 Vcs-Git: https://salsa.debian.org/multimedia-team/sonivox.git
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 
 Package: libsonivox3
