=== debian/changelog ===
sonivox (3.6.15-2) unstable; urgency=medium

  * Source-only upload

 -- Dennis Braun <snd@debian.org>  Sun, 05 Jan 2025 18:39:03 +0100

sonivox (3.6.15-1) unstable; urgency=medium

  * New upstream version 3.6.15
  * Bump Standards-Version to 4.7.0
  * Provide the sonivoxrender package
  * Disable unit-tests generally, because it needs to download a dst file
  * Remove multiarch tag from sonivoxrender package
    Thanks to Pedro Lopez-Cabanilla!

 -- Dennis Braun <snd@debian.org>  Sat, 04 Jan 2025 19:08:13 +0100
