## sonivox 3.6.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #[=========================================================================[
-  Copyright (c) 2022-2024 Pedro López-Cabanillas
+  Copyright (c) 2022-2025 Pedro López-Cabanillas
 
   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
@@ -18,7 +18,7 @@
 
 project( sonivox
     LANGUAGES C CXX
-    VERSION 3.6.15.0
+    VERSION 3.6.16.0
 )
 
 # GoogleTest requires at least C++14
@@ -40,7 +40,7 @@
 
 include(GNUInstallDirs)
 
-set(PROJECT_RELEASE_DATE "December 14, 2024")
+set(PROJECT_RELEASE_DATE "April 13, 2025")
 
 if (BUILD_TESTING)
     find_package(GTest CONFIG)
@@ -127,6 +127,7 @@
     arm-wt-22k/host_src/eas_chorus.h
     arm-wt-22k/host_src/eas_reverb.h
     arm-wt-22k/host_src/eas_types.h
+    arm-wt-22k/host_src/eas_report.h
 #arm-wt-22k/host_src/jet.h
 )
 
@@ -306,8 +307,17 @@
         )
     endif()
 
-    set(SOUNDFONT "$ENV{TEMP}/soundfont.dls")
+    if(DEFINED ENV{TEMP})
+        set(TEMPDIR "$ENV{TEMP}")
+    elseif(DEFINED ENV{XDG_RUNTIME_DIR})
+        set(TEMPDIR "$ENV{XDG_RUNTIME_DIR}")
+    else()
+        message(FATAL_ERROR "Cannot find a temporary directory. Define the TEMP environment variable.")
+    endif()
+
+    set(SOUNDFONT "${TEMPDIR}/soundfont.dls")
     if (NOT EXISTS ${SOUNDFONT})
+        message(STATUS "Downloading DLS file for testing to ${SOUNDFONT}")
         file(DOWNLOAD "http://www.ronimusic.com/sf2/Airfont_340.dls" ${SOUNDFONT})
     endif()
 
@@ -315,6 +325,9 @@
     file(MD5 ${SOUNDFONT} SOUNDFONTHASH)
     message(STATUS "DLS file ${SOUNDFONT} size: ${SOUNDFONTSIZE}")
     message(STATUS "DLS file ${SOUNDFONT} MD5 hash: ${SOUNDFONTHASH}")
+    if (NOT (SOUNDFONTSIZE EQUAL 81362584 AND SOUNDFONTHASH STREQUAL "40c0cd4ad29ae411a8fc3d6681002a2b"))
+        message(FATAL_ERROR "The downloaded DLS file is corrupted.")
+    endif()
 
     include( GoogleTest )
     gtest_discover_tests( SonivoxTest EXTRA_ARGS "-P${CMAKE_CURRENT_SOURCE_DIR}/test/res/" DISCOVERY_TIMEOUT 300 )
