=== debian/changelog ===
sonivox (3.6.16-1) unstable; urgency=medium

  * New upstream version 3.6.16
  * Bump Standards-Version to 4.7.2

 -- Dennis Braun <snd@debian.org>  Sun, 28 Sep 2025 20:00:41 +0200
