=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Homepage: https://github.com/pedrolcl/sonivox
 Vcs-Browser: https://salsa.debian.org/multimedia-team/sonivox
 Vcs-Git: https://salsa.debian.org/multimedia-team/sonivox.git
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 
 Package: libsonivox3
