=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	dh_auto_configure
#else
#	dh_auto_configure -- -DBUILD_TESTING=OFF
#endif
	dh_auto_configure -- -DBUILD_TESTING=OFF
