=== debian/watch ===
version=4
opts=dversionmangle=auto \
  https://github.com/pedrolcl/@PACKAGE@/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
